#include <iostream>
#include <vector>
#include <algorithm>
using namespace std;

int main()
{
    unsigned long long int n, q, k=0; // k  je br dana u nizu nakon sto spojim preseke, tj menja i
    cin >> n >> q;

    vector<pair<unsigned long long int, unsigned long long int>> niz(n); // pamti dan i kupljenu plazmu, ovo stavljamo za prostor jer su brojevi bas apsurdno veliki

    unsigned long long int trn, plazme;
    cin >> trn >> plazme;
        niz[k++] = {trn, plazme};// da bi mogao da spojim sve preseke pri unosu

    while(n>1)// ne idemo ceo n zbog onog jednog koraka
    {
        cin >> trn >> plazme;// nov unos

        if(niz[k-1].first + niz[k-1].second >trn)// presek postoji
        {
            niz[k-1].second += plazme;
            k--;
        }

        else// presek ne postoji
        {
            niz[k] = {trn, plazme};
        }
        k++;
        n--;
    }

    // u nizu sad ostaju neki prazni elementi ali znamo dokle ih ima zbog k
    // popravicu ako stignem !!!!!!!!!!!!!!!!!
    n=k;


    unsigned long long int pitanje, i =0, trenutna=0;
    while(q>0)
    {
        cin >> pitanje;// samo dan za koj nas zanima

        if(pitanje >= niz[0].first)// ako je vece ili jednako prvom danu kupovine
        {
            // idemo do granice n jer postoje slucajevi gde je neophodno naci jos veci dan
            while(pitanje>= niz[i].first +niz[i].second && i<n) // ako je van granice trenuntnog dana i njegovih plazmi
            {
                trenutna+=niz[i].second;// dodajemo sve koje smo prosli
                i++;
            }

            if(pitanje < niz[i].first)
                cout << trenutna << "\n";

            else if(pitanje < niz[i].first + niz[i].second)// u okviru je trenutnih plazmi
            {
                cout << trenutna + pitanje - niz[i].first + 1 << "\n";
            }

            else
            {
                cout << trenutna << "\n";
            }


        }

        else // ako je manje od najmanjeg dana
            cout << 0 << "\n";


        q--;
    }



    return 0;
}